=== debian/changelog ===
otb (7.1.0+dfsg-1build1) groovy; urgency=medium

  * No-change rebuild against libgdal27

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jun 2020 23:14:40 +0000

otb (7.1.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update 7.1.0~rc1 symbols for i386.
  * Strip pre-release from symbols version.
  * Update 7.1.0 symbols for amd64.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 17 Mar 2020 18:48:25 +0100

otb (7.1.0~rc1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Bump Standards-Version to 4.5.0, no changes.
  * Update copyright years for Centre National d'Etudes Spatiales.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 14 Feb 2020 17:58:11 +0100
